Name:       chiliproject
Version:    3.8.0

Release:    %mkrel 4
Summary:    A web-based project management system
Group:      Networking/WWW
License:    GPLv2+
URL:        https://www.chiliproject.org
Source0:    https://www.chiliproject.org/attachments/download/58/%{name}-%{version}.tar.gz
Source101:  %{name}.logrotate
Source102:  %{name}.httpd
Source103:  %{name}-pg-database.yml
Source104:  README.urpmi
# basic BR
BuildRequires: rubygems
BuildRequires: rubygem(rails)
BuildRequires: rubygem(rack)
BuildRequires: rubygem(mocha)
BuildRequires: rubygem(shoulda) >= 2.10.3

BuildRequires: rubygem(edavis10-object_daddy)
# database and connectors
BuildRequires: mysql
BuildRequires: rubygem(mysql)
BuildRequires: postgresql-server
BuildRequires: rubygem(pg)
BuildRequires: rubygem(sqlite3)
BuildRequires: rubygem(bundler)
# vcs
BuildRequires: git-core
BuildRequires: mercurial
BuildRequires: cvs
BuildRequires: subversion-server
# for testsuite
BuildRequires: rubygem(coderay)
BuildRequires: rubygem(rubytree)
BuildRequires: rubygem(fastercsv) >= 1.5.0
 
BuildRequires: rubygem(ruby-openid) >= 2.1.4
BuildRequires: rubygem(rmagick)
BuildRequires: rubygem(rdoc)

Requires:   webserver
Requires:   rubygem(rails) >= 2.3.14
Requires:   rubygem(rack) >= 1.1.2
Requires:   rubygems
Requires:   %{name}-db
Requires:   rubygem(coderay) >= 0.9.7
Requires:   rubygem(rubytree) >= 0.5.2
Requires:   rubygem(fastercsv) >= 1.5.0
Requires:   rubygem(ruby-openid) >= 2.1.4
Requires:   rubygem(rmagick)
Requires:   rubygem(rdoc)
Requires:   rubygem(bundler)
# Only suggests rubygem-passenger, after all, it can work with fcgi too
Suggests:   rubygem(passenger)
Suggests:   %{name}-scm
Suggests:   %{name}-httpd

BuildArch:  noarch

%description
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

* Project planning

  - Set up a Roadmap containing all the tasks and deadline.
  - Discuss your plan using a Gantt chart.

* Issue tracking and progress reporting

  - Get your things done by setting up issues for every task.
  - Discuss the work within the issue.
  - Get automatically notified by e-mail when a colleague updates the status of an issue.
  - Update an issue by replying to a notification by e-mail.
  - Keep informed about what is currently going on by subscribing to a project's activity as a news feed.

* Sharing knowledge collaboratively

  - Use Wiki to create, to document and to share information with your team members.
  - If you develop software, integrate your code repository such as Subversion or Git. Browse your repository within your internet browser. Update issues by referencing them in your commit messages.
  - Share and update documents and files.

* Keep control of your expenses

  - Track the time you spent on tasks
  - Create detailed reports describing where your time went.

* Interact with externals

  - Provide official project news to everybody interested in the project.
  - Provide forums so that people can discuss your project and help each other.

* Setup your work flows to support your business processes.

  - Setup issue types by creating trackers so issues can follow a specific work flow.
  - Define roles and their permissions within a work flow.

* Extend it.

  - Optimize your installation to support your specific needs by extending it with Plugins provided by third parties.

#-------------------------------------------------------------------------------
%package        pg
Summary:    A flexible project management web application - pgsql connector
Group:      Networking/WWW
Requires:   rubygem(pg)
Provides:   %{name}-pg = %{version}-%{release}
Provides:   %{name}-db = %{version}-%{release}

%description    pg
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use postgresql as
chiliproject's database backend.

%files          pg
%defattr(-,root,root,-)
%{_var}/www/%{name}/config/database.postgres.yml
#-------------------------------------------------------------------------------
%package        mysql
Summary:    A flexible project management web application - mysql connector
Group:      Networking/WWW
Requires:   rubygem(mysql)
Provides:   %{name}-mysql = %{version}-%{release}
Provides:   %{name}-db    = %{version}-%{release}
%description    mysql
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use mysql as chiliproject's
database backend.

%files          mysql
%defattr(-,root,root,-)
%config(noreplace) %{_var}/www/%{name}/config/database.yml
#-------------------------------------------------------------------------------
%package        sqlite
Summary:    A flexible project management web application - sqlite connector
Group:      Networking/WWW
Requires:   rubygem(sqlite3)
Provides:   %{name}-sqlite = %{version}-%{release}
Provides:   %{name}-db     = %{version}-%{release}

%description    sqlite
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use sqlite as chiliproject's
database backend.

%files          sqlite
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        git
Summary:    A flexible project management web application - git backend
Group:      Networking/WWW
Requires:   git-core
Provides:   %{name}-git = %{version}-%{release}
Provides:   %{name}-scm = %{version}-%{release}

%description    git
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use git as chiliproject's
version control system backend

%files          git
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        svn
Summary:    A flexible project management web application - subversion backend
Group:      Networking/WWW
Requires:   subversion
Provides:   %{name}-svn = %{version}-%{release}
Provides:   %{name}-scm = %{version}-%{release}

%description    svn
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use subversion as chiliproject's
version control system backend

%files          svn
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        hg
Summary:    A flexible project management web application - mercurial backend
Group:      Networking/WWW
Requires:   mercurial
Provides:   %{name}-hg  = %{version}-%{release}
Provides:   %{name}-scm = %{version}-%{release}

%description    hg
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use mercurial as chiliproject's
version control system backend

%files          hg
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        bzr
Summary:    A flexible project management web application - bzr backend
Group:      Networking/WWW
Requires:   bzr
Provides:   %{name}-bzr = %{version}-%{release}
Provides:   %{name}-scm = %{version}-%{release}

%description    bzr
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use bazaar as chiliproject's
version control system backend

%files          bzr
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        cvs
Summary:    A flexible project management web application - cvs backend
Group:      Networking/WWW
Requires:   cvs
Provides:   %{name}-cvs = %{version}-%{release}
Provides:   %{name}-scm = %{version}-%{release}

%description    cvs
ChiliProject is a web based project management system. It supports your team
throughout the complete project life cycle, from setting up and discussing a
project plan, over tracking issues and reporting work progress to
collaboratively sharing knowledge.

This package contains the needed modules to use cvs as chiliproject's
version control system backend

%files          cvs
%defattr(-,root,root,-)
#------------------------------------------------------------------------------
%package        httpd
Summary:    A flexible project management web application - apache modules
Group:      Networking/WWW
Requires:   %{name}

%description    httpd

This module allow anonymous users to browse public project and
registred users to browse and commit their project. Authentication is
done against the chiliproject database or the LDAP configured in
chiliproject.

This method is far simpler than the one with pam_* and works with all
database without a hassle but you need to have apache/mod_perl on the
svn server

A default configuration for apache is also included

%files          httpd
%defattr(-,root,root,-)
%config(noreplace) %{_webappconfdir}/%{name}.conf
%{_var}/www/%{name}/extra/svn/Redmine.pm
#-------------------------------------------------------------------------------

%prep
%setup -q
cp %{SOURCE104} README.urpmi

%build


# Don’t include bundled rails
rm -rf vendor/rails

# Copy database.yml.example as it’s mandatory to run chiliproject
# add modifications for testing
sed '/test:/a\
  socket: var/lib/mysql.sock' config/database.yml.example > config/database.yml

# Likewise, add postgresql conf
install -D -m644 %{SOURCE103} config/database.postgres.yml


%install
rm -rf %buildroot
install -d %{buildroot}%{_var}/www/%{name}
cp -ax * %{buildroot}%{_var}/www/%{name}
rm -f %{buildroot}%{_var}/www/%{name}/README.urpmi

# Don't include some prebuilt binaries
rm -rf %{buildroot}%{_var}/www/%{name}/vendor/plugins/rfpdf/lib/fonts/ttf2ufm


# Add Logrotate script
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -D -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# Add httpd default conf
mkdir -p %{buildroot}%{_webappconfdir}
install -D -m644 %{SOURCE102} %{buildroot}%{_webappconfdir}/%{name}.conf

%post
# if upgrade from a previous installation
if [ $1 -gt 1 ] ; then
  pushd %{_var}/www/%{name}
  rake generate_session_store
  for logfile in `ls log/*.log` ; do
      railsenv=`echo ${logfile%%.*} |sed 's!.*/!!'`
      RAILS_ENV=$railsenv rake db:migrate
      RAILS_ENV=$railsenv rake db:migrate:plugins
  done
  rake tmp:cache:clear
  rake tmp:sessions:clear
  popd
fi


# This check doesn't work in teh build. So let's disable it.

# %check
## initialize mysql db
#mysql_install_db --datadir=$PWD/var/lib/mysql/ --user=$USER
# start an unprivileged instance
#/usr/sbin/mysqld --datadir=$PWD/var/lib/mysql \
#  --socket $PWD/var/lib/mysql.sock \
#  --pid-file $PWD/var/lib/mysqld.pid &
# seems to not be used by activerecord
#export MYSQL_SOCK=$PWD/var/lib/mysql.sock
#sleep 10
# create database
#echo "create database chiliproject_test character set utf8;" | mysql --socket $PWD/var/lib/mysql.sock
# test mysql
#rake generate_session_store
#RAILS_ENV=test rake db:migrate
#need to setup test repositories too, skipping at the moment
#rake test
#kill `cat $PWD/var/lib/mysqld.pid`


%files
%doc README.urpmi
%{_sysconfdir}/logrotate.d/%{name}
%doc %{_var}/www/%{name}/README.rdoc
%dir %{_var}/www/%{name}/
%{_var}/www/%{name}/app/
%dir %{_var}/www/%{name}/config/
%doc %{_var}/www/%{name}/config/*.example
%{_var}/www/%{name}/config/environments/
%{_var}/www/%{name}/config/locales/
%{_var}/www/%{name}/config/initializers/
%{_var}/www/%{name}/config/routes.rb
%{_var}/www/%{name}/config/boot.rb
%{_var}/www/%{name}/config/environment.rb
%{_var}/www/%{name}/config/preinitializer.rb
%{_var}/www/%{name}/config/settings.yml
%{_var}/www/%{name}/db/
%{_var}/www/%{name}/doc/
%exclude %{_var}/www/%{name}/extra/svn/Redmine.pm
%{_var}/www/%{name}/extra/
%{_var}/www/chiliproject/CONTRIBUTING.md
# Directory has to be owned by the user under which the webserver runs
# Since apache is the preferred webserver for many people simplify the
# process for those users, all webservers should belong
# to the same user.
%attr(0755,apache,apache) %{_var}/www/%{name}/files/
%{_var}/www/%{name}/Gemfile
%{_var}/www/%{name}/lib/
%attr(0755,apache,apache) %{_var}/www/%{name}/log/
%{_var}/www/%{name}/public/
%{_var}/www/%{name}/Rakefile
%{_var}/www/%{name}/script/
%{_var}/www/%{name}/test/
%attr(0755,apache,apache) %{_var}/www/%{name}/tmp/
%{_var}/www/%{name}/vendor/




%changelog
* Thu Dec 12 2013 spuhler <spuhler> 3.8.0-4.mga4
+ Revision: 556406
- removed obsolete BuildRequires: rubygem(ruby-debug19)
- removed obsolete Requires: rubygem(ruby-debug19)
- changed requires and buildreqires to ruby-debug19 from ruby-debug
-removed the lines
 * find . -name ".gitignore" -exec rm {} \;
 * -perl -pi -e 's!/usr/local/bin/ruby!/usr/bin/env ruby!' lib/faster_csv.rb
  * This file isn't in the source anymore

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild

* Mon May 06 2013 spuhler <spuhler> 3.8.0-1.mga4
+ Revision: 412420
- Removed the test section.
 -It doesn't work on a build environment
  Upgraded to version 3.8.0 stable
- removed 2.3.0-fix-gemfile.patch
- removed the fonts binary files

  + fwang <fwang>
    - bump rel
    - tighten requires

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Oct 30 2011 shikamaru <shikamaru> 2.3.0-2.mga2
+ Revision: 159939
- remove old suggests, add bundler as a requirement

* Sat Oct 29 2011 shikamaru <shikamaru> 2.3.0-1.mga2
+ Revision: 159868
- New version 2.3.0
- Drop patch, chiliproject-2.3.0 uses rails-2.3.14
  -> kudos to Felix Sch?\195?\164fer for taking care of rails security fixes :-)
- add dependencies
- fix file list
- add patch for Gemfile:
  So, I don?\226?\128?\153t have much time, and I?\226?\128?\153m no bundler expert so I don?\226?\128?\153t know how to do
  this another way?\226?\128?\166
  Basically I don?\226?\128?\153t know how to coerce bundler to use our gems. Rmagick
  requirement is largely outdated, and I?\226?\128?\153m pretty sure it can work with this
  version, same for pg and sqlite3. Since mysql2 isn?\226?\128?\153t there atm, I dropped it too
  from the Gemfile.
  The thing that?\226?\128?\153s bugging me is that bundler wants ruby-debug19, though we are
  still using mri ruby 1.8 -> FIXME !

  + dmorgan <dmorgan>
    - New version 2.0.0

* Fri Jun 24 2011 dams <dams> 1.4.0-1.mga2
+ Revision: 113162
- Update to 1.4.0

* Fri Jun 24 2011 sander85 <sander85> 1.2.0-3.mga2
+ Revision: 113146
- bump release for updated requires
- forgot to bump requires

* Fri Jun 24 2011 sander85 <sander85> 1.2.0-2.mga2
+ Revision: 113144
- rebuild for new ruby-rack

* Sun Mar 27 2011 shikamaru <shikamaru> 1.2.0-1.mga1
+ Revision: 78164
- New version 1.2.0
- fix typo and missing popd
- ease upgrade of chiliproject by running the necessary commands

* Tue Mar 22 2011 shikamaru <shikamaru> 1.1.0-3.mga1
+ Revision: 75734
- fix rails requires

* Fri Mar 04 2011 shikamaru <shikamaru> 1.1.0-2.mga1
+ Revision: 64273
- Fix httpd conf
- move the file to a standard location (conf/webapps.d)
- remove remaining redmine occurrences

* Mon Feb 28 2011 shikamaru <shikamaru> 1.1.0-1.mga1
+ Revision: 61865
- temporarily drop darcs
- imported package chiliproject

